/**
 * \file
 *
 * \brief ATMEL޲ϸ
 *
 * 쌠 (C) 2012 Atmel Corporation S\ς݁B
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef ATMEL_PARTS_H
#define ATMEL_PARTS_H

/**
 * \defgroup part_macros_group ATMEL޲ϸ
 *
 * ϸۂ̏W͗lXATMEL޲ǂ̌nƌnɑʂ܂B
 * ͺَ߲ɺނ޲ˑ̈ÎɎgp邱Ƃł܂B
 *
 * @{
 */

/**
 * \name ޲ɕ֗ϸ
 * @{
 */
//! 8ޯAVRpGCCIAR޲`
#define AVR8_PART_IS_DEFINED(part) \
	(defined(__ ## part ## __) || defined(__AVR_ ## part ## __))

//! 32ޯAVRpGCCIAR޲`
#define AVR32_PART_IS_DEFINED(part) \
	(defined(__AT32 ## part ## __) || defined(__AVR32_ ## part ## __))

//! SAMpGCCIAR޲`
#define SAM_PART_IS_DEFINED(part) (defined(__ ## part ## __))
/** @} */

/**
 * \defgroup uc3_part_macros_group AVR UC3޲
 * @{
 */

/**
 * \name AVR UC3 An
 * @{
 */
#define UC3A0 ( \
		AVR32_PART_IS_DEFINED(UC3A0128) || \
		AVR32_PART_IS_DEFINED(UC3A0256) || \
		AVR32_PART_IS_DEFINED(UC3A0512)    \
	)

#define UC3A1 ( \
		AVR32_PART_IS_DEFINED(UC3A1128) || \
		AVR32_PART_IS_DEFINED(UC3A1256) || \
		AVR32_PART_IS_DEFINED(UC3A1512)    \
	)

#define UC3A3 ( \
		AVR32_PART_IS_DEFINED(UC3A364)   || \
		AVR32_PART_IS_DEFINED(UC3A364S)  || \
		AVR32_PART_IS_DEFINED(UC3A3128)  || \
		AVR32_PART_IS_DEFINED(UC3A3128S) || \
		AVR32_PART_IS_DEFINED(UC3A3256)  || \
		AVR32_PART_IS_DEFINED(UC3A3256S)    \
	)

#define UC3A4 ( \
		AVR32_PART_IS_DEFINED(UC3A464)   || \
		AVR32_PART_IS_DEFINED(UC3A464S)  || \
		AVR32_PART_IS_DEFINED(UC3A4128)  || \
		AVR32_PART_IS_DEFINED(UC3A4128S) || \
		AVR32_PART_IS_DEFINED(UC3A4256)  || \
		AVR32_PART_IS_DEFINED(UC3A4256S)    \
	)
/** @} */

/**
 * \name AVR UC3 Bn
 * @{
 */
#define UC3B0 ( \
		AVR32_PART_IS_DEFINED(UC3B064)  || \
		AVR32_PART_IS_DEFINED(UC3B0128) || \
		AVR32_PART_IS_DEFINED(UC3B0256) || \
		AVR32_PART_IS_DEFINED(UC3B0512)    \
	)

#define UC3B1 ( \
		AVR32_PART_IS_DEFINED(UC3B164)  || \
		AVR32_PART_IS_DEFINED(UC3B1128) || \
		AVR32_PART_IS_DEFINED(UC3B1256) || \
		AVR32_PART_IS_DEFINED(UC3B1512)    \
	)
/** @} */

/**
 * \name AVR UC3 Cn
 * @{
 */
#define UC3C0 ( \
		AVR32_PART_IS_DEFINED(UC3C064C)  || \
		AVR32_PART_IS_DEFINED(UC3C0128C) || \
		AVR32_PART_IS_DEFINED(UC3C0256C) || \
		AVR32_PART_IS_DEFINED(UC3C0512C)    \
	)

#define UC3C1 ( \
		AVR32_PART_IS_DEFINED(UC3C164C)  || \
		AVR32_PART_IS_DEFINED(UC3C1128C) || \
		AVR32_PART_IS_DEFINED(UC3C1256C) || \
		AVR32_PART_IS_DEFINED(UC3C1512C)    \
	)

#define UC3C2 ( \
		AVR32_PART_IS_DEFINED(UC3C264C)  || \
		AVR32_PART_IS_DEFINED(UC3C2128C) || \
		AVR32_PART_IS_DEFINED(UC3C2256C) || \
		AVR32_PART_IS_DEFINED(UC3C2512C)    \
	)
/** @} */

/**
 * \name AVR UC3 Dn
 * @{
 */
#define UC3D3 ( \
		AVR32_PART_IS_DEFINED(UC64D3)  || \
		AVR32_PART_IS_DEFINED(UC128D3)    \
	)

#define UC3D4 ( \
		AVR32_PART_IS_DEFINED(UC64D4)  || \
		AVR32_PART_IS_DEFINED(UC128D4)    \
	)
/** @} */

/**
 * \name AVR UC3 Ln
 * @{
 */
#define UC3L0 ( \
		AVR32_PART_IS_DEFINED(UC3L016) || \
		AVR32_PART_IS_DEFINED(UC3L032) || \
		AVR32_PART_IS_DEFINED(UC3L064)    \
	)

#define UC3L0128 ( \
		AVR32_PART_IS_DEFINED(UC3L0128) \
	)

#define UC3L0256 ( \
		AVR32_PART_IS_DEFINED(UC3L0256) \
	)

#define UC3L3 ( \
		AVR32_PART_IS_DEFINED(UC64L3U)  || \
		AVR32_PART_IS_DEFINED(UC128L3U) || \
		AVR32_PART_IS_DEFINED(UC256L3U)    \
	)

#define UC3L4 ( \
		AVR32_PART_IS_DEFINED(UC64L4U)  || \
		AVR32_PART_IS_DEFINED(UC128L4U) || \
		AVR32_PART_IS_DEFINED(UC256L4U)    \
	)

#define UC3L3_L4 (UC3L3 || UC3L4)
/** @} */

/**
 * \name AVR UC3n
 * @{
 */
/** AVR UC3 An */
#define UC3A (UC3A0 || UC3A1 || UC3A3 || UC3A4)

/** AVR UC3 Bn */
#define UC3B (UC3B0 || UC3B1)

/** AVR UC3 Cn */
#define UC3C (UC3C0 || UC3C1 || UC3C2)

/** AVR UC3 Dn */
#define UC3D (UC3D3 || UC3D4)

/** AVR UC3 Ln */
#define UC3L (UC3L0 || UC3L0128 || UC3L0256 || UC3L3_L4)
/** @} */

/** AVR UC3i */
#define UC3  (UC3A || UC3B || UC3C || UC3D || UC3L)

/** @} */

/**
 * \defgroup xmega_part_macros_group AVR XMEGA޲
 * @{
 */

/**
 * \name AVR XMEGA An
 * @{
 */
#define XMEGA_A1 ( \
		AVR8_PART_IS_DEFINED(ATxmega64A1)  || \
		AVR8_PART_IS_DEFINED(ATxmega128A1)    \
	)

#define XMEGA_A3 ( \
		AVR8_PART_IS_DEFINED(ATxmega64A3)  || \
		AVR8_PART_IS_DEFINED(ATxmega128A3) || \
		AVR8_PART_IS_DEFINED(ATxmega192A3) || \
		AVR8_PART_IS_DEFINED(ATxmega256A3)    \
	)

#define XMEGA_A3B ( \
		AVR8_PART_IS_DEFINED(ATxmega256A3B) \
	)

#define XMEGA_A4 ( \
		AVR8_PART_IS_DEFINED(ATxmega16A4) || \
		AVR8_PART_IS_DEFINED(ATxmega32A4)    \
	)
/** @} */

/**
 * \name AVR XMEGA AUn
 * @{
 */
#define XMEGA_A1U ( \
		AVR8_PART_IS_DEFINED(ATxmega64A1U)  || \
		AVR8_PART_IS_DEFINED(ATxmega128A1U)    \
	)

#define XMEGA_A3U ( \
		AVR8_PART_IS_DEFINED(ATxmega64A3U)  || \
		AVR8_PART_IS_DEFINED(ATxmega128A3U) || \
		AVR8_PART_IS_DEFINED(ATxmega192A3U) || \
		AVR8_PART_IS_DEFINED(ATxmega256A3U)    \
	)

#define XMEGA_A3BU ( \
		AVR8_PART_IS_DEFINED(ATxmega256A3BU) \
	)

#define XMEGA_A4U ( \
		AVR8_PART_IS_DEFINED(ATxmega16A4U)  || \
		AVR8_PART_IS_DEFINED(ATxmega32A4U)  || \
		AVR8_PART_IS_DEFINED(ATxmega64A4U)  || \
		AVR8_PART_IS_DEFINED(ATxmega128A4U)    \
	)
/** @} */

/**
 * \name AVR XMEGA Bn
 * @{
 */
#define XMEGA_B1  ( \
		AVR8_PART_IS_DEFINED(ATxmega64B1)  || \
		AVR8_PART_IS_DEFINED(ATxmega128B1)    \
	)

#define XMEGA_B3  ( \
		AVR8_PART_IS_DEFINED(ATxmega64B3)  || \
		AVR8_PART_IS_DEFINED(ATxmega128B3)    \
	)
/** @} */

/**
 * \name AVR XMEGA Cn
 * @{
 */
#define XMEGA_C3 ( \
		AVR8_PART_IS_DEFINED(ATxmega384C3)  || \
		AVR8_PART_IS_DEFINED(ATxmega256C3)  || \
		AVR8_PART_IS_DEFINED(ATxmega128C3)  || \
		AVR8_PART_IS_DEFINED(ATxmega64C3)     \
	)

#define XMEGA_C4 ( \
		AVR8_PART_IS_DEFINED(ATxmega32C4)  || \
		AVR8_PART_IS_DEFINED(ATxmega16C4)     \
	)
/** @} */

/**
 * \name AVR XMEGA Dn
 * @{
 */
#define XMEGA_D3 ( \
		AVR8_PART_IS_DEFINED(ATxmega64D3)  || \
		AVR8_PART_IS_DEFINED(ATxmega128D3) || \
		AVR8_PART_IS_DEFINED(ATxmega192D3) || \
		AVR8_PART_IS_DEFINED(ATxmega256D3) || \
		AVR8_PART_IS_DEFINED(ATxmega384D3)    \
	)

#define XMEGA_D4 ( \
		AVR8_PART_IS_DEFINED(ATxmega16D4)  || \
		AVR8_PART_IS_DEFINED(ATxmega32D4)  || \
		AVR8_PART_IS_DEFINED(ATxmega64D4)  || \
		AVR8_PART_IS_DEFINED(ATxmega128D4)    \
	)
/** @} */

/**
 * \name AVR XMEGAn
 * @{
 */
/** AVR XMEGA An */
#define XMEGA_A (XMEGA_A1 || XMEGA_A3 || XMEGA_A3B || XMEGA_A4)

/** AVR XMEGA AUn */
#define XMEGA_AU (XMEGA_A1U || XMEGA_A3U || XMEGA_A3BU || XMEGA_A4U)

/** AVR XMEGA Bn */
#define XMEGA_B (XMEGA_B1 || XMEGA_B3)

/** AVR XMEGA Cn */
#define XMEGA_C (XMEGA_C3 || XMEGA_C4)

/** AVR XMEGA Dn */
#define XMEGA_D (XMEGA_D3 || XMEGA_D4)
/** @} */

/** AVR XMEGAi */
#define XMEGA (XMEGA_A || XMEGA_AU || XMEGA_B || XMEGA_C || XMEGA_D)

/** @} */

/**
 * \defgroup mega_part_macros_group megaAVR޲
 *
 * \note megaAVRQ޲ ͯ ̧قɑ΂AVR Libcł̌QɊÂ
 * B͌magaAVR޲nn̖Oł͂܂B
 *
 * @{
 */

/**
 * \name ATmegaxx0/xx1Q
 * @{
 */
#define MEGA_XX0 ( \
		AVR8_PART_IS_DEFINED(ATmega640)  || \
		AVR8_PART_IS_DEFINED(ATmega1280) || \
		AVR8_PART_IS_DEFINED(ATmega2560)    \
	)

#define MEGA_XX1 ( \
		AVR8_PART_IS_DEFINED(ATmega1281) || \
		AVR8_PART_IS_DEFINED(ATmega2561)    \
	)
/** @} */

/**
 * \name megaAVRQ
 * @{
 */
/** ATmegaxx0/xx1Q */
#define MEGA_XX0_1 (MEGA_XX0 || MEGA_XX1)

/** ATmegaxx4Q */
#define MEGA_XX4 ( \
		AVR8_PART_IS_DEFINED(ATmega164A)  || \
		AVR8_PART_IS_DEFINED(ATmega164PA) || \
		AVR8_PART_IS_DEFINED(ATmega324)   || \
		AVR8_PART_IS_DEFINED(ATmega324A)  || \
		AVR8_PART_IS_DEFINED(ATmega324PA) || \
		AVR8_PART_IS_DEFINED(ATmega644)   || \
		AVR8_PART_IS_DEFINED(ATmega644A)  || \
		AVR8_PART_IS_DEFINED(ATmega644PA) || \
		AVR8_PART_IS_DEFINED(ATmega1284P)   || \
		AVR8_PART_IS_DEFINED(ATmega128RFA1)   \
	)

/** ATmegaxx4Q */
#define MEGA_XX4_A ( \
		AVR8_PART_IS_DEFINED(ATmega164A)  || \
		AVR8_PART_IS_DEFINED(ATmega164PA) || \
		AVR8_PART_IS_DEFINED(ATmega324A)  || \
		AVR8_PART_IS_DEFINED(ATmega324PA) || \
		AVR8_PART_IS_DEFINED(ATmega644A)  || \
		AVR8_PART_IS_DEFINED(ATmega644PA) || \
		AVR8_PART_IS_DEFINED(ATmega1284P)    \
	)

/** ATmegaxx8Q */
#define MEGA_XX8 ( \
		AVR8_PART_IS_DEFINED(ATmega48)    || \
		AVR8_PART_IS_DEFINED(ATmega48A)   || \
		AVR8_PART_IS_DEFINED(ATmega48PA)  || \
		AVR8_PART_IS_DEFINED(ATmega88)    || \
		AVR8_PART_IS_DEFINED(ATmega88A)   || \
		AVR8_PART_IS_DEFINED(ATmega88PA)  || \
		AVR8_PART_IS_DEFINED(ATmega168)   || \
		AVR8_PART_IS_DEFINED(ATmega168A)  || \
		AVR8_PART_IS_DEFINED(ATmega168PA) || \
		AVR8_PART_IS_DEFINED(ATmega328)   || \
		AVR8_PART_IS_DEFINED(ATmega328P)     \
	)

/** ATmegaxx8A/P/PAQ */
#define MEGA_XX8_A ( \
		AVR8_PART_IS_DEFINED(ATmega48A)   || \
		AVR8_PART_IS_DEFINED(ATmega48PA)  || \
		AVR8_PART_IS_DEFINED(ATmega88A)   || \
		AVR8_PART_IS_DEFINED(ATmega88PA)  || \
		AVR8_PART_IS_DEFINED(ATmega168A)  || \
		AVR8_PART_IS_DEFINED(ATmega168PA) || \
		AVR8_PART_IS_DEFINED(ATmega328P)     \
	)

/** ATmegaxxQ */
#define MEGA_XX ( \
		AVR8_PART_IS_DEFINED(ATmega16)   || \
		AVR8_PART_IS_DEFINED(ATmega16A)  || \
		AVR8_PART_IS_DEFINED(ATmega32)   || \
		AVR8_PART_IS_DEFINED(ATmega32A)  || \
		AVR8_PART_IS_DEFINED(ATmega64)   || \
		AVR8_PART_IS_DEFINED(ATmega64A)  || \
		AVR8_PART_IS_DEFINED(ATmega128)  || \
		AVR8_PART_IS_DEFINED(ATmega128A)    \
	)

/** ATmegaxxA/P/PAQ */
#define MEGA_XX_A ( \
		AVR8_PART_IS_DEFINED(ATmega16A)  || \
		AVR8_PART_IS_DEFINED(ATmega32A)  || \
		AVR8_PART_IS_DEFINED(ATmega64A)  || \
		AVR8_PART_IS_DEFINED(ATmega128A)    \
	)

/** wS */
#define MEGA_UNSPECIFIED ( \
		AVR8_PART_IS_DEFINED(ATmega16)    || \
		AVR8_PART_IS_DEFINED(ATmega16A)   || \
		AVR8_PART_IS_DEFINED(ATmega32)    || \
		AVR8_PART_IS_DEFINED(ATmega32A)   || \
		AVR8_PART_IS_DEFINED(ATmega64)    || \
		AVR8_PART_IS_DEFINED(ATmega64A)   || \
		AVR8_PART_IS_DEFINED(ATmega128)   || \
		AVR8_PART_IS_DEFINED(ATmega128A)  || \
		AVR8_PART_IS_DEFINED(ATmega169P)  || \
		AVR8_PART_IS_DEFINED(ATmega169PA) || \
		AVR8_PART_IS_DEFINED(ATmega329P)  || \
		AVR8_PART_IS_DEFINED(ATmega329PA)    \
	)
/** @} */

/** megaAVRi */
#define MEGA (MEGA_XX0_1 || MEGA_XX4 || MEGA_XX8 || MEGA_XX || MEGA_UNSPECIFIED)

/** @} */

/**
 * \defgroup sam_part_macros_group SAM޲
 * @{
 */

/**
 * \name SAM3Sn
 * @{
 */
#define SAM3S1 ( \
		SAM_PART_IS_DEFINED(SAM3S1A) || \
		SAM_PART_IS_DEFINED(SAM3S1B) || \
		SAM_PART_IS_DEFINED(SAM3S1C)    \
	)

#define SAM3S2 ( \
		SAM_PART_IS_DEFINED(SAM3S2A) || \
		SAM_PART_IS_DEFINED(SAM3S2B) || \
		SAM_PART_IS_DEFINED(SAM3S2C)    \
	)

#define SAM3S4 ( \
		SAM_PART_IS_DEFINED(SAM3S4A) || \
		SAM_PART_IS_DEFINED(SAM3S4B) || \
		SAM_PART_IS_DEFINED(SAM3S4C)    \
	)

#define SAM3S8 ( \
		SAM_PART_IS_DEFINED(SAM3S8B) || \
		SAM_PART_IS_DEFINED(SAM3S8C)    \
	)

#define SAM3SD8 ( \
		SAM_PART_IS_DEFINED(SAM3SD8B) || \
		SAM_PART_IS_DEFINED(SAM3SD8C)    \
	)
/** @} */

/**
 * \name SAM3Un
 * @{
 */
#define SAM3U1 ( \
		SAM_PART_IS_DEFINED(SAM3U1C) || \
		SAM_PART_IS_DEFINED(SAM3U1E)    \
	)

#define SAM3U2 ( \
		SAM_PART_IS_DEFINED(SAM3U2C) || \
		SAM_PART_IS_DEFINED(SAM3U2E)    \
	)

#define SAM3U4 ( \
		SAM_PART_IS_DEFINED(SAM3U4C) || \
		SAM_PART_IS_DEFINED(SAM3U4E)    \
	)
/** @} */

/**
 * \name SAM3Nn
 * @{
 */
#define SAM3N1 ( \
		SAM_PART_IS_DEFINED(SAM3N1A) || \
		SAM_PART_IS_DEFINED(SAM3N1B) || \
		SAM_PART_IS_DEFINED(SAM3N1C)    \
	)

#define SAM3N2 ( \
		SAM_PART_IS_DEFINED(SAM3N2A) || \
		SAM_PART_IS_DEFINED(SAM3N2B) || \
		SAM_PART_IS_DEFINED(SAM3N2C)    \
	)

#define SAM3N4 ( \
		SAM_PART_IS_DEFINED(SAM3N4A) || \
		SAM_PART_IS_DEFINED(SAM3N4B) || \
		SAM_PART_IS_DEFINED(SAM3N4C)    \
	)
/** @} */

/**
 * \name SAM3Xn
 * @{
 */
#define SAM3X4 ( \
		SAM_PART_IS_DEFINED(SAM3X4C) || \
		SAM_PART_IS_DEFINED(SAM3X4E)    \
	)

#define SAM3X8 ( \
		SAM_PART_IS_DEFINED(SAM3X8C) || \
		SAM_PART_IS_DEFINED(SAM3X8E) || \
		SAM_PART_IS_DEFINED(SAM3X8H)    \
	)
/** @} */

/**
 * \name SAM3An
 * @{
 */
#define SAM3A4 ( \
		SAM_PART_IS_DEFINED(SAM3A4C)    \
	)

#define SAM3A8 ( \
		SAM_PART_IS_DEFINED(SAM3A8C)    \
	)
/** @} */

/**
 * \name SAM4Sn
 * @{
 */
#define SAM4S8 ( \
		SAM_PART_IS_DEFINED(SAM4S8B) || \
		SAM_PART_IS_DEFINED(SAM4S8C)    \
	)

#define SAM4S16 ( \
		SAM_PART_IS_DEFINED(SAM4S16B) || \
		SAM_PART_IS_DEFINED(SAM4S16C)    \
	)
/** @} */

/**
 * \name SAM4Ln
 * @{
 */
#define SAM4LS ( \
		SAM_PART_IS_DEFINED(ATSAM4LS2A) || \
		SAM_PART_IS_DEFINED(ATSAM4LS2B) || \
		SAM_PART_IS_DEFINED(ATSAM4LS2C) || \
		SAM_PART_IS_DEFINED(ATSAM4LS4A) || \
		SAM_PART_IS_DEFINED(ATSAM4LS4B) || \
		SAM_PART_IS_DEFINED(ATSAM4LS4C) \
	)

#define SAM4LC ( \
		SAM_PART_IS_DEFINED(ATSAM4LC2A) || \
		SAM_PART_IS_DEFINED(ATSAM4LC2B) || \
		SAM_PART_IS_DEFINED(ATSAM4LC2C) || \
		SAM_PART_IS_DEFINED(ATSAM4LC4A) || \
		SAM_PART_IS_DEFINED(ATSAM4LC4B) || \
		SAM_PART_IS_DEFINED(ATSAM4LC4C) \
	)
/** @} */

/**
 * \name SAMn
 * @{
 */
/** SAM3Sn */
#define SAM3S (SAM3S1 || SAM3S2 || SAM3S4 || SAM3S8 || SAM3SD8)

/** SAM3Un */
#define SAM3U (SAM3U1 || SAM3U2 || SAM3U4)

/** SAM3Nn */
#define SAM3N (SAM3N1 || SAM3N2 || SAM3N4)

/** SAM3XAn */
#define SAM3XA (SAM3X4 || SAM3X8 || SAM3A4 || SAM3A8)

/** SAM4Sn */
#define SAM4S (SAM4S8 || SAM4S16)

/** SAM4Ln */
#define SAM4L (SAM4LS || SAM4LC)
/** @} */

/** SAMi */
#define SAM (SAM3S || SAM3U || SAM3N || SAM3XA || SAM4S || SAM4L)

/** @} */

/** @} */

#endif /* ATMEL_PARTS_H */
